class LinearPoint extends Point {
	move() {
		const [p1, p2, k] = this.pre;
		const new_point = linear_point_xy(p1, p2, k);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function command_linear_point(x, y) {
	const obj = get_object_at(x, y, points);
	if (obj) {
		selected_objects.push(obj);
	}
	if (selected_objects.length === 2) {
		const k = Number(prompt('输入比值K'));
		const label = prompt('输入新点的标签');
		if (k && label && !points.some(p => p.label === label)) {
			const [p1, p2] = selected_objects;
			const {x, y} = linear_point_xy(p1, p2, k);
			const linear_point = new LinearPoint(x, y, label);
			linear_point.free = false;
			linear_point.pre = [p1, p2, k];
			linear_point.tikz = `\\tkzDefPointWith[linear,K=${k}](${p1.label},${p2.label})\\tkzGetPoint{${label}}`;
			points.push(linear_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
		selected_objects = [];
		draw();
	}
}

/**
 * 计算比例点的 xy 坐标
 * @param p1 点 p1
 * @param p2 点 p2
 * @return 返回使得 p1c: p1p2 = k 的点 c 的坐标
 */
function linear_point_xy(p1, p2, k) {
	if (!p1.exist || !p2.exist) return null;
	return {'x': k * p2.x + (1 - k) * p1.x, 'y': k * p2.y + (1 - k) * p1.y};
}
