class MidPoint extends Point {
	move() {
		const [point1, point2] = this.pre;
		const new_point = mid_point_xy(point1, point2);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function command_midpoint(x, y) {
	const point = get_object_at(x, y, points);
	if (point) {
		selected_objects.push(point);
	}
	if (selected_objects.length === 2) {
		const label = prompt('输入中点的标签');
		if (label && !points.some(p => p.label === label)) {
			const [p1, p2] = selected_objects;
			const {x, y} = mid_point_xy(p1, p2);
			let mid_point = new MidPoint(x, y, label);
			mid_point.pre = [p1, p2];
			mid_point.free = false;
			mid_point.tikz = `\\tkzDefMidPoint(${p1.label},${p2.label})\\tkzGetPoint{${label}}`;
			points.push(mid_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
		selected_objects = [];
		draw();
	}
}

/**
 * 计算中点的 xy 坐标
 * @param p1 点 p1
 * @param p2 点 p2
 * @return 返回点 p1, p2 的中点坐标
 */
function mid_point_xy(p1, p2) {
	if (!p1.exist || !p2.exist) return null;
	return {'x': (p1.x + p2.x) / 2, 'y': (p1.y + p2.y) / 2};
}
