class OrthoCenter extends Point {
	move() {
		const [p1, p2, p3] = this.pre;
		const new_point = ortho_center_xy(p1, p2, p3);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function command_ortho_center(x, y) {
	const obj = get_object_at(x, y, points);
	if (obj) {
		selected_objects.push(obj);
	}
	if (selected_objects.length === 3) {
		const label = prompt('输入垂心的标签');
		if (label && !points.some(p => p.label === label)) {
			const [p1, p2, p3] = selected_objects;
			const {x, y} = ortho_center_xy(p1, p3, p2);
			const ortho_center = new OrthoCenter(x, y, label);
			ortho_center.free = false;
			ortho_center.pre = [p1, p2, p3];
			ortho_center.tikz = `\\tkzDefTriangleCenter[ortho](${p1.label},${p2.label},${p3.label})\\tkzGetPoint{${label}}`;
			points.push(ortho_center);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
		selected_objects = [];
		draw();
	}
}
