class ParallelPoint extends Point {
	move() {
		const [point, segment] = this.pre;
		const new_point = parallel_point_xy(point, segment);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}


function command_parallel(x, y) {
	const obj = get_object_at(x, y, [...points, ...segments]);
	if (obj) {
		selected_objects.push(obj);
	}
	if (selected_objects.length === 2) {
		const [point, segment] = selected_objects;
		if (point instanceof Point && segment instanceof Segment) {
			const label = prompt('输入平行线上一点的标签');
			if (label && !points.some(p => p.label === label)) {
				const {x, y} = parallel_point_xy(point, segment);
				const parallel_point = new ParallelPoint(x, y, label);
				parallel_point.free = false;
				parallel_point.pre = [point, segment];
				parallel_point.tikz = `\\tkzDefLine[parallel=through ${point.label}](${segment.point1.label},${segment.point2.label})\\tkzGetPoint{${label}}`;
				points.push(parallel_point);
			} else {
				alert('标签是全局唯一的，不能重复');
			}
		}
		selected_objects = [];
		draw();
	}
}


/**
 * 计算平行线上一点的 xy 坐标
 * @param point 平行线外一点 point
 * @param segment 线段 segment
 * @return 返回过点 point 作线段 segment 的平行线，所得平行线上一点的坐标
 */
function parallel_point_xy(point, segment) {
	if (!point.exist || !segment.point1.exist || !segment.point2.exist) return null;
	const x = segment.point2.x - segment.point1.x + point.x;
	const y = segment.point2.y - segment.point1.y + point.y;
	return {'x': x, 'y': y};
}
