class Point {
	constructor(x, y, label) {
		this.x = x;
		this.y = y;
		this.label = label;
		// 是否是自由点
		this.free = true;
		// 前驱对象
		this.pre = [];
		// 是否被隐藏
		this.hidden = false;
		// 是否存在
		this.exist = true;
		this.color = 'black';
		this.tikz = '';
		this.label_position = 'below right';
	}
}

function command_point(x, y) {
	const label = prompt('输入点的标签');
	if (label && !points.some(p => p.label === label)) {
		const point = new Point(x, y, label);
		points.push(point);
		draw();
	} else {
		alert('标签是全局唯一的，不能重复');
	}
}

const label_positions = ['left', 'below left', 'below', 'below right', 'right', 'above right', 'above', 'above left'];

function command_label(x, y) {
	const point = get_object_at(x, y, points);
	if (point) {
		const label = prompt('输入新的标签');
		if (label && !points.some(p => p.label === label)) {
			point.label = label;
			draw();
		} else {
			alert('标签是全局唯一的，不能重复');
		}
	}
}

function command_coordinate(x, y) {
	const point = get_object_at(x, y, points);
	if (point && point.free) {
		const [xx, yy] = prompt('输入新的xy坐标，以英文逗号分隔').split(',');
		if (!isNaN(xx) && !isNaN(yy)) {
			const [x, y] = [Number(xx), Number(yy)];
			if (Math.abs(x) < 4 && Math.abs(y) < 3) {
				point.x = x * 100;
				point.y = y * 100;
				update_dependent_objects(point);
				draw();			
			} else {
				alert('坐标越出可视边界');
			}
		}
	}
}

function command_position(x, y) {
	const point = get_object_at(x, y, points);
	if (point) {
		// 获取当前标签位置的索引
		const current_index = label_positions.indexOf(point.label_position);
		// 获取下一个标签位置
		const new_index = (current_index + 1) % label_positions.length;
		point.label_position = label_positions[new_index];
		draw();
	}
}
