class PointCC extends Point {
	move() {
		const [circle1, circle2, num] = this.pre;
		const new_point = interCC(circle1, circle2)[num];
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function create_inter_CC(circle1, circle2) {
	const inters = interCC(circle1, circle2);
	if (inters[0]) {
		const label0 = prompt('输入交点0的标签');
		if (label0 && !points.some(p => p.label === label0)) {
			let inter_point = new PointCC(inters[0].x, inters[0].y, label0);
			inter_point.pre = [circle1, circle2, 0];
			inter_point.free = false;
			inter_point.tikz = `\\tkzInterCC(${circle1.center.label},${circle1.point.label})(${circle2.center.label},${circle2.point.label})\\tkzGetFirstPoint(${label0})`;
			points.push(inter_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
	}
	if (inters[1]) {
		const label1 = prompt('输入交点1的标签');
		if (label1 && !points.some(p => p.label === label1)) {
			let inter_point = new PointCC(inters[1].x, inters[1].y, label1);
			inter_point.pre = [circle1, circle2, 1];
			inter_point.free = false;
			inter_point.tikz = `\\tkzInterCC(${circle1.center.label},${circle1.point.label})(${circle2.center.label},${circle2.point.label})\\tkzGetSecondPoint(${label1})`;
			points.push(inter_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
	}
}
/**
 * 计算两个圆的交点 xy 坐标
 * @param circle1 圆 circle1
 * @param circle2 圆 circle2
 * @return 返回圆 circle1 和圆 circle2 的交点坐标数组。一般情况有两个交点，数组有两个元素
 */
function interCC(circle1, circle2) {
	if (!circle1.center.exist || !circle1.point.exist || !circle2.center.exist || !circle2.point.exist) return null;
	const cx1 = circle1.center.x;
	const cy1 = circle1.center.y;
	const radius1 = Math.hypot(circle1.point.x - circle1.center.x, circle1.point.y - circle1.center.y);
	const cx2 = circle2.center.x;
	const cy2 = circle2.center.y;
	const radius2 = Math.hypot(circle2.point.x - circle2.center.x, circle2.point.y - circle2.center.y);

	const dx = cx2 - cx1;
	const dy = cy2 - cy1;
	const d = Math.hypot(dx, dy);

	if (d > radius1 + radius2 || d < Math.abs(radius1 - radius2) || d === 0) {
		return [];
	}

	const a = (radius1 * radius1 - radius2 * radius2 + d * d) / (2 * d);
	const h = Math.sqrt(radius1 * radius1 - a * a);
	const x2 = cx1 + (dx * a) / d;
	const y2 = cy1 + (dy * a) / d;
	const rx = -dy * (h / d);
	const ry = dx * (h / d);

	const intersection1 = {'x': x2 + rx, 'y': y2 + ry};
	const intersection2 = {'x': x2 - rx, 'y': y2 - ry};

	return [intersection1, intersection2];
}
