class PointLC extends Point {
	move() {
		const [segment, circle, num] = this.pre;
		const new_point = interLC(segment, circle)[num];
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function create_inter_LC(segment, circle) {
	const inters = interLC(segment, circle);
	if (inters[0]) {
		const label0 = prompt('输入交点0的标签');
		if (label0 && !points.some(p => p.label === label0)) {
			let inter_point = new PointLC(inters[0].x, inters[0].y, label0);
			inter_point.pre = [segment, circle, 0];
			inter_point.free = false;
			inter_point.tikz = `\\tkzInterLC(${segment.point1.label},${segment.point2.label})(${circle.center.label},${circle.point.label})\\tkzGetFirstPoint(${label0})`;
			points.push(inter_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
	}
	if (inters[1]) {
		const label1 = prompt('输入交点1的标签');
		if (label1 && !points.some(p => p.label === label1)) {
			let inter_point = new PointLC(inters[1].x, inters[1].y, label1);
			inter_point.pre = [segment, circle, 1];
			inter_point.free = false;
			inter_point.tikz = `\\tkzInterLC(${segment.point1.label},${segment.point2.label})(${circle.center.label},${circle.point.label})\\tkzGetSecondPoint(${label1})`;
			points.push(inter_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
	}
}

/**
 * 计算线段和圆的交点 xy 坐标
 * @param segment 线段 segment
 * @param circle 圆 circle
 * @return 返回线段 segment 所在直线和圆 circle 的交点坐标数组。一般情况有两个交点，数组有两个元素
 */
function interLC(segment, circle) {
	if (!segment.point1.exist || !segment.point2.exist || !circle.center.exist || !circle.point.exist) return null;
	const cx = circle.center.x;
	const cy = circle.center.y;
	const radius = Math.hypot(circle.point.x - circle.center.x, circle.point.y - circle.center.y);
	const x1 = segment.point1.x;
	const y1 = segment.point1.y;
	const x2 = segment.point2.x;
	const y2 = segment.point2.y;

	const dx = x2 - x1;
	const dy = y2 - y1;
	const A = dx * dx + dy * dy;
	const B = 2 * (dx * (x1 - cx) + dy * (y1 - cy));
	const C = (x1 - cx) * (x1 - cx) + (y1 - cy) * (y1 - cy) - radius * radius;
	const det = B * B - 4 * A * C;

	let intersections = [];
	if (det >= 0) {
		const sqrt_det = Math.sqrt(det);
		const t1 = (-B + sqrt_det) / (2 * A);
		const t2 = (-B - sqrt_det) / (2 * A);
		intersections.push({'x': (x1 + t1 * dx), 'y': (y1 + t1 * dy)});
		intersections.push({'x': (x1 + t2 * dx), 'y': (y1 + t2 * dy)});
	}
	return intersections;
}
