class PointLL extends Point {
	move() {
		const [segment1, segment2] = this.pre;
		const new_point = interLL(segment1, segment2);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function create_inter_LL(segment1, segment2) {
	const inter = interLL(segment1, segment2);
	if (inter) {
		const label = prompt('输入交点的标签');
		if (label && !points.some(p => p.label === label)) {
			let inter_point = new PointLL(inter.x, inter.y, label);
			inter_point.pre = [segment1, segment2];
			inter_point.free = false;
			inter_point.tikz = `\\tkzInterLL(${segment1.point1.label},${segment1.point2.label})(${segment2.point1.label},${segment2.point2.label})\\tkzGetPoint(${label})`;
			points.push(inter_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
	}
}
/**
 * 线段的交点 xy 坐标
 * @param segment1 线段 segment1
 * @param segment2 线段 segment2
 * @return 返回线段 segment1 所在直线和线段 segment2 所在直线的交点坐标
 */
function interLL(segment1, segment2) {
	if (!segment1.point1.exist || !segment1.point2.exist || !segment2.point1.exist || !segment2.point2.exist) return null;
	const x1 = segment1.point1.x;
	const y1 = segment1.point1.y;
	const x2 = segment1.point2.x;
	const y2 = segment1.point2.y;
	const x3 = segment2.point1.x;
	const y3 = segment2.point1.y;
	const x4 = segment2.point2.x;
	const y4 = segment2.point2.y;

	const denom = (y4 - y3) * (x2 - x1) - (x4 - x3) * (y2 - y1);
	if (denom === 0) {
		return null;
	}
	const ua = ((x4 - x3) * (y1 - y3) - (y4 - y3) * (x1 - x3)) / denom;
	const ub = ((x2 - x1) * (y1 - y3) - (y2 - y1) * (x1 - x3)) / denom;

	if (ua >= 0 && ua <= 1 && ub >= 0 && ub <= 1) {
		const x = x1 + ua * (x2 - x1);
		const y = y1 + ua * (y2 - y1);
		return {'x': x, 'y': y};
	}
	return null;
}
