class RotatePoint extends Point {
	move() {
		const [point, center, angle] = this.pre;
		const new_point = rotate_point_xy(point, center, angle);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}
function command_rotate(x, y) {
	const point = get_object_at(x, y, points);
	if (point) {
		selected_objects.push(point);
	}
	if (selected_objects.length === 2) {
		const angle = prompt('输入旋转角度');
		const label = prompt('输入旋转后点的标签');
		if (angle && label && !points.some(p => p.label === label)) {
			const [p, center] = selected_objects;
			const {x, y} = rotate_point_xy(p, center, angle);
			const rotate_point = new RotatePoint(x, y, label);
			rotate_point.pre = [p, center, angle];
			rotate_point.free = false;
			rotate_point.tikz = `\\tkzDefPointBy[rotation= center ${center.label} angle ${angle}](${point.label})\\tkzGetPoint{${rotate_point.label}}`;
			points.push(rotate_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
		selected_objects = [];
		draw();
	}
}

/**
 * 计算旋转点的 xy 坐标
 * @param point 被旋转的点
 * @param center 旋转中心
 * @param angle 旋转角度
 * @return 返回点 point 绕点 center 逆时针旋转 angle 度角后所得的点的坐标
 */
function rotate_point_xy(point, center, angle) {
	if (!point.exist || !center.exist) return null;
	const rad = (Math.PI / 180) * angle;
	const newX = Math.cos(rad) * (point.x - center.x) - Math.sin(rad) * (point.y - center.y) + center.x;
	const newY = Math.sin(rad) * (point.x - center.x) + Math.cos(rad) * (point.y - center.y) + center.y;
			
	return {'x': newX, 'y': newY};
}
