class SymmetryPoint extends Point {
	move() {
		const [point, center] = this.pre;
		const new_point = symmetry_point_xy(point, center);
		if (new_point) {
			this.exist = true;
			this.x = new_point.x;
			this.y = new_point.y;
		} else {
			this.exist = false;
		}
	}
}

function command_symmetry(x, y) {
	const obj = get_object_at(x, y, points);
	if (obj) {
		selected_objects.push(obj);
	}
	if (selected_objects.length === 2) {
		const label = prompt('输入对称点的标签');
		if (label && !points.some(p => p.label === label)) {
			const [point, center] = selected_objects;
			const {x, y} = symmetry_point_xy(point, center);
			const sym_point = new SymmetryPoint(x, y, label);
			sym_point.free = false;
			sym_point.pre = [point, center];
			sym_point.tikz = `\\tkzDefPointBy[symmetry=center ${center.label}](${point.label})\\tkzGetPoint{${label}}`;
			points.push(sym_point);
		} else {
			alert('标签是全局唯一的，不能重复');
		}
		selected_objects = [];
		draw();
	}
}


/**
 * 计算中心对称点的 xy 坐标
 * @param point 被对称的点 point
 * @param center 对称中心 center
 * @return 返回点 point 关于点 center 的中心对称点
 */
function symmetry_point_xy(point, center) {
	if (!point.exist || !center.exist) return null;
	const x = 2 * center.x - point.x;
	const y = 2 * center.y - point.y;
	return {'x': x, 'y': y};
}
